[LeetCode - 哈希表] 1. Two Sum

1 问题

Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

2 分析

使用 lt rt 表示满足目标条件:

nums[lt]+nums[rt]=target(1)
的下标值. 根据(1)式,如果我们求出序列 nums 中的所有两两组合的值,然后逐一与 target 比较,是可以求出 lt rt 的。在长度为 n 的序列中,有 C2n 个组合,因此这种算法的时间复杂度是 O(n2)
这种算法显然效率不够高,通过观察(1)式,有:
nums[lt]=targetnums[rt](2)
这样问题可以转化为:在长度为 n 的序列中,给定 nums[lt], 查找 nums[rt] 是否存在. 执行查找操作效率最高的数据结构是哈希表, 查找操作的时间复杂度是 O(1) 。按照这种思路,需要将 nums[rt] 存储在哈希表中, 那么可以按照如下方式构建哈希表:
key:numsvalue:
因此遍历一次序列,对序列中的每一个元素,在哈希表上执行查找操作,便可以求出答案,时间复杂度是 nO(1)=O(n)
(2)式具有对称性,即可以根据 nums[lt] ,查找 nums[rt] , 也可以根据 nums[rt] 查找 nums[lt] 。因此,只需要遍历一次序列,第一次遇到 lt 时将其加入哈希表中,在遇到 rt 时,便可以确定其为最终解。

3 代码

Java 代码如下:

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
    throw new IllegalArgumentException("No two sum solution");
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值